Redmine - Feature #8121

Allow overriding direction of part of text
2011-04-10 17:00 - Ebrahim Mohammadi

Status: Closed Start date: 2011-04-10
Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Text formatting Estimated time: 0.00 hour
Target version: 3.0.0

Resolution: Fixed

Description

There should be a way to override direction of part of text. Maybe using <span dir="rtl"> and <p dir="rtl"> (needs permitting use of
"dir" HTML attribute and/or "direction" CSS attribute) or even better some nicer shorter Textile-ful syntax.

Upstream Textile supports <span dir="rtl">. It also supports another trick using CSS, but just for a complete paragraph (not some part
of it):

p{direction: rtl}.

This one doesn't work in Redmine too.

An example (paste it in some RTL context and view there):

pooooooD c++ 0000 O0O0OOD OO.

In this example "C++" is shown as "++C" in an RTL context, while it should be shown like result of the following HTML snippet:
<p dir="rtl1">0000000 <div dir="ltr">C++</div> 0000 0000 O00.</p>

(The "C++" example is a simple one to show the problem. I'm aware of workaround of writing it as "++C", but that's just a

workaround. And even if someone prefers to go the workaround way, working around more complex examples can be very more
difficult.)

Related issues:
Related to Redmine - Defect #27884: RTL wiki class broken in Redmine 3.2.6 Closed
Has duplicate Redmine - Feature #11784: {direction:rtl} doesn't work in text ... Closed

Associated revisions

Revision 13951 - 2015-01-27 22:29 - Jean-Philippe Lang

Adds rtl and ltr css classes for use in text formatting (#8121).

History

#1 - 2011-04-10 17:38 - jayaram nagarkoti

- Assignee set to Anonymous

#2 - 2011-04-11 09:20 - Etienne Massip

- Assignee deleted (Anonymous)

#3 - 2011-04-11 09:33 - Etienne Massip

- Tracker changed from Defect to Feature

#4 - 2011-04-29 09:42 - Ebrahim Mohammadi

Actually | should have used a span tag instead of div:

<p dir="rtl1">0000000 <span dir="ltr">C++</span> 0000 0000 00.</p>

#5 - 2013-04-20 11:27 - Boaz Rymland

I'd be happy to see this one implemented. TIA!
#6 - 2015-01-22 07:11 - Ali Nadalizadeh

Temporary fix for persian users which converts the whole wiki paragraph to RTL (once detects persian/arabic content):

<script>
$ (document) .ready (function () {

S.each($(".wiki, .wiki-edit"), function (i, v) {
var txt = $(v).text();
for(ci in txt) {
if (txt.charCodeAt (ci) > 0x600 && txt.charCodeAt (ci) < 0x700) {
$(v).css("direction", "rtl");

break;
}
}
1)
$.each($(".issue .subject a"), function (i, v) {
var txt = $(v).text();

console.log (txt);
for(ci in txt) {
if (txt.charCodeAt (ci) > 0x600 && txt.charCodeAt (ci) < 0x700) {

$(v) .parent () .css("direction", "rtl");
$(v) .parent () .css("text-align", "right");
break;

</script>

Append the code above to the main layout file (app/views/layouts/base.html.erb) or any other javascript file which is included in all pages.

#7 - 2015-01-22 09:42 - Boaz Rymland
Thanks for sharing, Ali!

#8 - 2015-01-27 22:31 - Jean-Philippe Lang
- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version set to 3.0.0

- Resolution set to Fixed

2 builtin css classes (rtl and ltr) are added in r13951.
You can use them with textile formatting by using parenthesis, here on a paragraph and a span:

p(rtl). 0000000 & (ltr)c++% 0000 0000 OD.
#9 - 2017-12-30 15:19 - Hooman Valibeigi
Jean-Philippe Lang wrote:

2 builtin css classes (rtl and Itr) are added in r13951.
You can use them with textile formatting by using parenthesis, here on a paragraph and a span:

(-]

This fix is broken.
My environment: Redmine 3.4.2, Google Chrome 63
Take this example:

Textile:

p(rtl). 00 000 test 000D

Generated html:
https://www.redmine.org/projects/redmine/repository/svn/revisions/13951
https://www.redmine.org/projects/redmine/repository/svn/revisions/13951

<p class="wiki-class-rt1">00 000 test 000</p>
First of all there is no such class as "wiki-class-rtl" in application.css.

Second, "unicode-bidi:bidi-override" makes the LTR parts of an RTL paragraph printed in reverse. e.g. 'tset' instead of 'test'. Simply having direction:rtl
would make everything work just fine.

#10 - 2018-01-14 16:08 - Toshi MARUYAMA

Hooman Valibeigi wrote:

Jean-Philippe Lang wrote:

FTR: #27884.

#11 - 2018-04-07 11:27 - Jean-Philippe Lang
- Related to Defect #27884: RTL wiki class broken in Redmine 3.2.6 added
https://www.redmine.org/issues/27884
http://www.tcpdf.org

